import { getModelToken } from '@nestjs/mongoose';
import { Test, TestingModule } from '@nestjs/testing';
import { CreateCategoriesAccompagnement } from '../dto/create-categoriesAccompagnement.dto';
import { CategoriesAccompagnementService } from './categories-accompagnement.service';

describe('CategoriesAccompagnementService', () => {
  let service: CategoriesAccompagnementService;

  const mockCategoriesAccompagnementModel = {
    create: jest.fn(),
    find: jest.fn(),
  };

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [],
      providers: [
        CategoriesAccompagnementService,
        {
          provide: getModelToken('CategoriesAccompagnement'),
          useValue: mockCategoriesAccompagnementModel,
        },
      ],
    }).compile();

    service = module.get<CategoriesAccompagnementService>(CategoriesAccompagnementService);
  });

  it('should be defined', () => {
    expect(service).toBeDefined();
  });

  it('should create categorie accompagnement', async () => {
    const data: CreateCategoriesAccompagnement = { name: 'test', modules: [{ id: 'Test', text: 'Text du test' }] };
    const _doc = { _id: '5fbb92ef80a5c257dc0161f2', ...data };
    mockCategoriesAccompagnementModel.create.mockResolvedValueOnce(_doc);
    expect(await service.create(data)).toEqual(_doc);
  });

  it('should findAll structures', async () => {
    const data: CreateCategoriesAccompagnement[] = [
      { name: 'test', modules: [{ id: 'Test', text: 'Text du test' }] },
      { name: 'test2', modules: [{ id: 'Test2', text: 'Text du test test 2' }] },
    ];
    mockCategoriesAccompagnementModel.find.mockResolvedValueOnce(data);
    expect(await service.findAll()).toEqual(data);
  });
});
