import { Injectable } from '@nestjs/common';
import { InjectModel } from '@nestjs/mongoose';
import { Model } from 'mongoose';
import { CreateCategoriesOthers } from '../dto/create-categoriesOthers.dto';
import { CategoriesOthers, CategoriesOthersDocument } from '../schemas/categoriesOthers.schema';

@Injectable()
export class CategoriesOthersService {
  constructor(@InjectModel(CategoriesOthers.name) private structureModel: Model<CategoriesOthersDocument>) {}

  public async create(createDto: CreateCategoriesOthers): Promise<CategoriesOthers> {
    return this.structureModel.create(createDto);
  }

  public async findAll(): Promise<CategoriesOthers[]> {
    return this.structureModel.find();
  }
}
