import { HttpModule, Module } from '@nestjs/common';
import { MongooseModule } from '@nestjs/mongoose';
import { TempUser, TempUserSchema } from './temp-user.schema';
import { TempUserService } from './temp-user.service';
import { TempUserController } from './temp-user.controller';
import { MailerModule } from '../mailer/mailer.module';

@Module({
  imports: [MongooseModule.forFeature([{ name: TempUser.name, schema: TempUserSchema }]), HttpModule, MailerModule],
  providers: [TempUserService],
  exports: [TempUserService],
  controllers: [TempUserController],
})
export class TempUserModule {}
