import { HttpException, HttpStatus } from '@nestjs/common';
import { PendingStructureDto } from '../../../src/admin/dto/pending-structure.dto';
import { LoginDto } from '../../../src/auth/login-dto';

export class UsersServiceMock {
  findOne(mail: string, passwordQuery?: boolean) {
    if (mail === 'pauline.dupont@mii.com') {
      return {
        _id: 'tsfsf6296',
        validationToken:
          'cf1c74c22cedb6b575945098db42d2f493fb759c9142c6aff7980f252886f36ee086574ee99a06bc99119079257116c959c8ec870949cebdef2b293666dbca42',
        emailVerified: true,
        email: 'pauline.dupont@mii.com',
        password: '$2a$12$vLQjJ9zAWyUwiFLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
        role: 0,
        name: 'DUPONT',
        surname: 'Pauline',
      };
    }
    if (mail === 'jacques.dupont@mii.com') {
      if (passwordQuery) {
        return {
          _id: 'tsfsf6296',
          validationToken:
            'cf1c74c22cedb6b575945098db42d2f493fb759c9142c6aff7980f252886f36ee086574ee99a06bc99119079257116c959c8ec870949cebdef2b293666dbca42',
          emailVerified: false,
          email: 'jacques.dupont@mii.com',
          password: '$2a$12$vLQjJ9zAWyUwiFLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
          role: 0,
        };
      }
      return {
        _id: 'tsfsf6296',
        validationToken:
          'cf1c74c22cedb6b575945098db42d2f493fb759c9142c6aff7980f252886f36ee086574ee99a06bc99119079257116c959c8ec870949cebdef2b293666dbca42',
        emailVerified: false,
        email: 'jacques.dupont@mii.com',
        role: 0,
      };
    }
    return null;
  }

  findByLogin({ email, password }: LoginDto) {
    const user = this.findOne(email, true);

    if (!user) {
      throw new HttpException('Invalid credentials', HttpStatus.UNAUTHORIZED);
    }

    let areEqual = true;
    if (password === '1') {
      areEqual = false;
    }

    if (!areEqual) {
      throw new HttpException('Invalid credentials', HttpStatus.UNAUTHORIZED);
    }

    return user;
  }

  getPendingStructures() {
    return [
      {
        structureId: '6093ba0e2ab5775cfc01ed3e',
        structureName: 'a',
        userEmail: 'paula.dubois@mii.com',
      },
      {
        structureId: '6903ba0e2ab5775cfc01ed4d',
        structureName: "L'Atelier Numérique",
        userEmail: 'jacques.dupont@mii.com',
      },
    ];
  }

  validatePendingStructure(): PendingStructureDto[] {
    return this.getPendingStructures();
  }

  deleteOneId(id: string) {
    if (id === 'tsfsf6296') {
      return {
        _id: 'tsfsf6296',
        validationToken:
          'cf1c74c22cedb6b575945098db42d2f493fb759c9142c6aff7980f252886f36ee086574ee99a06bc99119079257116c959c8ec870949cebdef2b293666dbca42',
        emailVerified: true,
        email: 'pauline.dupont@mii.com',
        password: '$2a$12$vLQjJ9zAWyUwiFLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
        role: 0,
        name: 'DUPONT',
        surname: 'Pauline',
        structuresLink: ['abcdefgh', '18sfqfq'],
      };
    }
    throw new HttpException('Invalid user id', HttpStatus.BAD_REQUEST);
  }

  isStructureClaimed(id: string) {
    if (id === 'abcdefgh') {
      return new Promise((resolve) => {
        resolve({
          _id: 'abcdefgh',
          validationToken:
            'cf1c74c22cedb6b575945098db42d2f493fb759c9142c6aff7980f252886f36ee086574ee99a06bc99119079257116c959c8ec870949cebdef2b293666dbca42',
          emailVerified: true,
          email: 'pauline.dupont@mii.com',
          password: '$2a$12$vLQjJ9zAWyUwiFLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
          role: 0,
          name: 'DUPONT',
          surname: 'Pauline',
          structuresLink: ['abcdefgh', '18sfqfq', '6093ba0e2ab5775cfc01fffe'],
        });
      });
    }
    return new Promise((resolve) => {
      resolve(null);
    });
  }

  searchUsers(searchString: string) {
    if (searchString === 'a@a.com') {
      return [
        {
          structureOutdatedMailSent: [],
          pendingStructuresLink: ['6001a48e16b08100062e4180', '6093ba0e2ab5775cfc01fffe'],
          structuresLink: ['6093ba0e2ab5775cfc01fffe'],
          newEmail: null,
          changeEmailToken: null,
          role: 0,
          resetPasswordToken: null,
          validationToken:
            'b2b6caca1d38ca26d203b5f12b0d925df2928fab8ee7ccf9bbe78802ffa625f5abce825783bc62d0b11be5a90132cf5045a9a7776f01694c63b60bf64b0f680f',
          emailVerified: false,
          _id: '6036721022462b001334c4bb',
          email: 'a@a.com',
          name: 'Xavier',
          surname: 'NIEL',
          phone: '06 11 11 11 11',
          password: '$2a$12$vLQjJ9zAWyUwiXLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
          __v: 1,
        },
      ];
    }
    return [];
  }

  findAll() {
    return [
      {
        structureOutdatedMailSent: [],
        pendingStructuresLink: ['6001a48e16b08100062e4180', '6093ba0e2ab5775cfc01fffe'],
        structuresLink: ['6093ba0e2ab5775cfc01fffe'],
        newEmail: null,
        changeEmailToken: null,
        role: 0,
        resetPasswordToken: null,
        validationToken:
          'b2b6caca1d38ca26d203b5f12b0d925df2928fab8ee7ccf9bbe78802ffa625f5abce825783bc62d0b11be5a90132cf5045a9a7776f01694c63b60bf64b0f680f',
        emailVerified: false,
        _id: '6036721022462b001334c4bb',
        email: 'a@a.com',
        name: 'Xavier',
        surname: 'NIEL',
        phone: '06 11 11 11 11',
        password: '$2a$12$vLQjJ9zAWyUwiXLeQDa6w.XzrlgPBhw.2GWrjog/yuEjIaZnQwmZu',
        __v: 1,
      },
      {
        structureOutdatedMailSent: [],
        pendingStructuresLink: ['6001a3c216b08100062e4169', '601d6aa2c94cf895c4e23860', '6093ba0e2ab5775cfc01fffe'],
        structuresLink: ['6037aa17d8189c0014f62421', '6093ba0e2ab5775cfc01fffe'],
        newEmail: null,
        changeEmailToken: null,
        role: 0,
        resetPasswordToken: null,
        validationToken: null,
        emailVerified: true,
        _id: '6037aa16d8189c0014f6241f',
        email: 'ptitduf@mii.com',
        name: 'hjhj',
        surname: 'hh',
        phone: '05 79 87 65 78',
        password: '$2a$12$vLQjJ9zAWyUwiXLeQDa6w.3KdcYb.cLqZzkX2rstcpc2QTgbJ0FlC',
        __v: 3,
      },
    ];
  }
}
